//----------------------------------------------------------------------
//  直接形 FIR マルチ・バンド・フィルタ
//
//  2023/01/16, Copyright (c) 2023 MIKAMI, Naoki
//----------------------------------------------------------------------

#include "MultirateLiPh.hpp"
#include "FIR_Direct.hpp"
#include "Coefs_FIR100th_2Passbands.hpp"
#pragma diag_suppress 870   // マルチバイト文字使用の警告抑制のため
using namespace Mikami;

const float FS_ = 10.0f;    // 入力の標本化周波数： 10 kHz
MultirateLiPh myAdDa_(FS_); // 出力標本化周波数を４倍にするオブジェクト
FirDirect df_(ORDER_, HK_); // 直接形 FIR フィルタのオブジェクト

// ADC 変換終了割込みに対する割込みサービス･ルーチン
void AdcIsr()
{
    float xn = myAdDa_.Input(); // 入力
    float yn = df_.Execute(xn); // FIR フィルタの処理
    myAdDa_.Output(yn);         // 出力
}

int main()
{
    printf("\r\n直接形 FIR フィルタ，マルチバンドフィルタを実行します\r\n");

    myAdDa_.Start(&AdcIsr);     // 標本化を開始する
    while (true) {}
}
